
Ruby - Bug #12232

Ripper.lex can't parse 2.3-style heredoc

03/30/2016 04:26 PM - rwz (Pavel Pravosud)

Status: Closed   

Priority: Normal   

Assignee:    

Target version:    

ruby -v: 2.3.0p0 Backport: 2.1: DONTNEED, 2.2: DONTNEED, 2.3:

DONE

Description

require "ripper"

Ripper.lex("<<~HEREDOC\nHEREDOC")

# => NoMethodError: undefined method `event' for #<Array:0x007fc25c07d598>

#        from /Users/rwz/.rvm/rubies/ruby-2.3.0/lib/ruby/2.3.0/ripper/lexer.rb:70:in `block in on_

heredoc_dedent'

#        from /Users/rwz/.rvm/rubies/ruby-2.3.0/lib/ruby/2.3.0/ripper/lexer.rb:69:in `each'

#        from /Users/rwz/.rvm/rubies/ruby-2.3.0/lib/ruby/2.3.0/ripper/lexer.rb:69:in `on_heredoc_d

edent'

#        from /Users/rwz/.rvm/rubies/ruby-2.3.0/lib/ruby/2.3.0/ripper/lexer.rb:61:in `parse'

#        from /Users/rwz/.rvm/rubies/ruby-2.3.0/lib/ruby/2.3.0/ripper/lexer.rb:61:in `parse'

#        from /Users/rwz/.rvm/rubies/ruby-2.3.0/lib/ruby/2.3.0/ripper/lexer.rb:55:in `lex'

#        from /Users/rwz/.rvm/rubies/ruby-2.3.0/lib/ruby/2.3.0/ripper/lexer.rb:44:in `lex'

Associated revisions

Revision 03228aabec1f0e036d4333dc94c7a82e3e6447f2 - 04/01/2016 05:08 PM - naruse (Yui NARUSE)

merge revision(s) 53722: [Backport #12232]

    * ext/ripper/lib/ripper/lexer.rb (on_heredoc_dedent): Fix

      Ripper.lex error in dedenting squiggly heredoc.  heredoc tree is

      also an array of Elem in the outer tree.  [Fix GH-1234]

 git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_2_3@54471 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 03228aab - 04/01/2016 05:08 PM - naruse (Yui NARUSE)

merge revision(s) 53722: [Backport #12232]

    * ext/ripper/lib/ripper/lexer.rb (on_heredoc_dedent): Fix

      Ripper.lex error in dedenting squiggly heredoc.  heredoc tree is

      also an array of Elem in the outer tree.  [Fix GH-1234]

 git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_2_3@54471 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

History

#1 - 03/31/2016 01:25 AM - nobu (Nobuyoshi Nakada)

- Status changed from Open to Closed

- Backport changed from 2.1: UNKNOWN, 2.2: UNKNOWN, 2.3: UNKNOWN to 2.1: DONTNEED, 2.2: DONTNEED, 2.3: REQUIRED

Fixed at r53722.

#2 - 04/12/2016 05:29 AM - naruse (Yui NARUSE)

- Backport changed from 2.1: DONTNEED, 2.2: DONTNEED, 2.3: REQUIRED to 2.1: DONTNEED, 2.2: DONTNEED, 2.3: DONE

ruby_2_3 r54471 merged revision(s) 53722.
